--camera
width = love.graphics.getWidth()
height = love.graphics.getHeight()
camera = {}
camera._x = 0
camera._y = 0
function camera:set()
  love.graphics.push()
  love.graphics.translate(-self._x, -self._y)
end

function camera:unset()
  love.graphics.pop()
end

function camera:move(dx, dy)
  self._x = self._x + (dx or 0)
  self._y = self._y + (dy or 0)
end


function camera:setX(value)
  if self._bounds then
    self._x = math.clamp(value, self._bounds.x1, self._bounds.x2)
  else
    self._x = value
  end
end

function camera:setY(value)
  if self._bounds then
    self._y = math.clamp(value, self._bounds.y1, self._bounds.y2)
  else
    self._y = value
  end
end

function camera:setPosition(x, y)
  if x then self:setX(x) end
  if y then self:setY(y) end
  
end

function camera:getBounds()
  return unpack(self._bounds)
end

function camera:setBounds(x1, y1, x2, y2)
  self._bounds = { x1 = x1, y1 = y1, x2 = x2, y2 = y2 }
end

function math.clamp(x, min, max)
  return x < min and min or (x > max and max or x)
end

--/camera

function make3d(file)
	local imageData = love.image.newImageData( file )
	local newimagedata = love.image.newImageData(imageData:getWidth()*3/2,  imageData:getHeight()*3/2)
	for i=imageData:getWidth()-1,0,-1 do
		for j=imageData:getHeight()-1,0,-1 do
			local r,g,b,a = imageData:getPixel(i,j)
			if i+j/2 < newimagedata:getWidth() then
				newimagedata:setPixel(math.floor(i+j/2),math.floor(j/2),r/2,g/2,b/2,a)
			end
		end
	end
	for i=imageData:getWidth()-1,0,-1 do
		for j=imageData:getHeight()-1,0,-1 do
			local r,g,b,a = imageData:getPixel(j,i)
			if i/2+j < newimagedata:getWidth() then
				newimagedata:setPixel(math.floor(j/2),math.floor(j/2+i),r*0.75,g*0.75,b*0.75,a)
			end
		end
	end
	for i=imageData:getWidth()-1,0,-1 do
		for j=imageData:getHeight()-1,0,-1 do
			local r,g,b,a = imageData:getPixel(i,j)
			newimagedata:setPixel(i+imageData:getWidth()/2,j+imageData:getHeight()/2,r,g,b,a)
		end
	end
	return love.graphics.newImage(newimagedata)
end
img = make3d("wall.png")
img2 = make3d("bri1.png")
imglst = {img2,img}
function alphaimage(file,alp)
	local shddata = love.image.newImageData( file )
	for i=0,shddata:getWidth()-1 do
		for j = 0, shddata:getHeight()-1 do
			local r,g,b,a = shddata:getPixel(i,j) 
			if r == 255 and g == 255 and b == 255 and a == 255 then
				shddata:setPixel(i,j,255,255,255,0)
			else
				shddata:setPixel(i,j,r,g,b,alp)
			end
		end
	end
	return love.graphics.newImage(shddata)
end
imgshd = alphaimage("shd.png",190)
imgpla2 = alphaimage("pla2.png",255)
plar = alphaimage("pla.png",255)
plal = alphaimage("pla3.png",255)
imgpla1 = plar
map = {
{
{2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,2,1,2,1,2,1,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,2,},
{2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,2,},
{2,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,2,2,2,},
{2,2,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,2,2,2,2,},
{2,2,2,2,1,0,0,0,0,0,0,2,0,1,0,0,0,0,0,0,2,0,0,0,0,2,2,2,2,2,},
{2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2}
},
{
{2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,1,0,0,0,2,1,2,1,2,1,2,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,2,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,2,2,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,2,2,2,2,},
{2,0,0,0,0,0,0,0,0,0,0,2,0,1,0,0,0,0,0,0,2,0,2,0,0,2,2,2,2,2,},
{2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2}
},
{
{2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,1,0,0,0,1,2,1,0,0,2,1,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,2,2,0,2,0,0,0,0,0,2,2,},
{2,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,2,0,2,0,0,0,0,2,2,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,2,2,2,2,},
{2,0,0,0,0,0,0,0,0,0,0,2,0,1,0,0,0,0,0,0,2,0,2,0,0,2,2,2,2,2,},
{2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2}
},
{
{2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,1,0,0,0,2,1,2,1,2,1,2,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,2,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,2,2,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,2,2,2,2,},
{2,0,0,0,0,0,0,0,0,0,0,2,0,1,0,0,0,0,0,0,2,0,2,0,0,2,2,2,2,2,},
{2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2}
},
{
{2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,0,0,0,1,2,1,2,1,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,2,},
{2,0,0,0,0,0,0,0,0,0,1,2,2,1,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,2,},
{2,0,0,0,0,0,0,0,0,1,2,2,2,1,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,0,1,2,2,2,2,1,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,2,},
{2,0,0,0,0,0,0,1,2,2,2,2,2,1,0,0,0,0,0,0,0,0,2,0,0,0,0,0,2,2,},
{2,0,0,0,0,0,1,2,2,2,2,2,2,1,0,0,0,0,0,0,0,0,2,0,0,0,0,2,2,2,},
{2,0,0,0,0,1,2,2,2,2,2,2,2,1,0,0,0,0,0,0,0,0,2,0,0,0,2,2,2,2,},
{2,0,0,0,1,2,2,2,2,2,2,2,2,1,0,0,0,0,0,0,0,0,2,0,0,2,2,2,2,2,},
{2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2}
},
}

local isleft = false
local isright = false
local isup = false
local isdown = false
local isin = false
local isout = false
local top = false
player = {
act_x=3*32,
act_y=3*32,
grid_x=3*32,
grid_y=3*32,
speedx = 4,
speedy = 4,
jumptime = 5,
actd3=0,
d3=0,
shadowy = 0,
dx=0,
dy=0,
dz=0,
ismoving = {x=false,y=false,z=false,overal=false,overalstate=true},		
}

function boundcamera()
	local x = #map[1][1]*32-width+32*2
    	if x < 0 then x = 0 end
    	local y = #map[1]*32-height+32*2
    	if y < 0 then y = 0 end
    	camera:setBounds(-64, -64, x, y)
end
boundcamera()

function savedynamic(bot,x,y) 
	dynamicmap[(bot.grid_y / 32)+y][(bot.grid_x / 32)+x] = 0
	if bot.atype == "player" then
		dynamicmap[(bot.grid_y / 32)][(bot.grid_x / 32)] = -1
	elseif bot.alive then
		dynamicmap[(bot.grid_y / 32)][(bot.grid_x / 32)] = bot.i
	end
end

function setisplayermowing(elem,state,dir)
    if elem.ismoving then
	elem.ismoving[dir] = state
	elem.ismoving.overal = (elem.ismoving.x  or elem.ismoving.y)
   end
end

function moveElement(elem,dt,dir,speed) 
   if not dir then
	moveElement(elem,dt,"x",elem.speedx)
	moveElement(elem,dt,"y",elem.speedy)
	
   else
	 
  	 if elem["act_"..dir] - elem["grid_"..dir] < 2*(32*speed*dt) and elem["grid_"..dir] - elem["act_"..dir] < 2*(32*speed*dt) then
 	     elem["act_"..dir] = elem["grid_"..dir]
	     setisplayermowing(elem,false,dir)
		 elem["d"..dir] = 0
 	  elseif not (elem["act_"..dir] - elem["grid_"..dir] < 2*(32*speed*dt)) then
 	     elem["act_"..dir] = elem["act_"..dir] - 32*speed*dt
	     setisplayermowing(elem,true,dir)
 	  elseif not (elem["grid_"..dir] - elem["act_"..dir] < 2*(32*speed*dt)) then
 	     elem["act_"..dir] = elem["act_"..dir] + 32*speed*dt
	     setisplayermowing(elem,true,dir)
 	  end
   end
end

function moveElement_d(elem,dt) 
    
  	 if elem.actd3 - elem.d3*16 < 2*(16*elem.speedx*dt) and elem.d3*16 - elem.actd3 < 2*(16*elem.speedx*dt) then
 	     elem.actd3 = elem.d3*16
	     elem.ismoving.z = false
		 elem.dz=0
 	  elseif not (elem.actd3 - elem.d3*16 < 2*(16*elem.speedx*dt)) then
 	     elem.actd3 = elem.actd3 - 16*elem.speedx*dt
	     elem.ismoving.z = true
 	  elseif not (elem.d3*16 - elem.actd3 < 2*(16*elem.speedx*dt)) then
 	     elem.actd3 = elem.actd3 + 16*elem.speedx*dt
	     elem.ismoving.z = true
 	  end
end

function moveGrid(elem,dir1,dir2,dir3,dir4) -- actual position change
	if elem["act_"..dir1] == elem["grid_"..dir1] then
        	elem["grid_"..dir1] = elem["grid_"..dir1] + dir2
		elem.direction = elem.grid_dir
		--savedynamic(elem,dir3,dir4)
		--rotOfsetElement(elem)
	end
end

function moveGrid_d(elem,dir3) 
	if elem.actd3 == elem.d3*16 then
        	elem.d3 = elem.d3 + dir3
	end
end

function rotOfsetElement(elem) 
	elem.direction = elem.grid_dir
	if elem.direction == 2 then 
		elem.draw_x = 32
		elem.draw_y = 32
	elseif elem.direction == 3 then
		elem.draw_y = 32
		elem.draw_x = 0
	elseif elem.direction == 1 then
		elem.draw_x = 32
		elem.draw_y = 0
	elseif elem.direction == 0 then
		elem.draw_x = 0
		elem.draw_y = 0
	end
end

function love.update(dt)
	--dt = 0.03
	--love.timer.sleep(0.05)
	moveElement(player,dt)
	moveElement_d(player,dt) 
	if player.ismoving then
    	  if (not player.ismoving.y) and isup and testBotMap(player,0, -2,"y",0,-1) then moveGrid(player,"y",-32,0,1) end
    	  if (not player.ismoving.y) and not isup and testBotMap(player,0, 1,"y",0,0) then moveGrid(player,"y",32,0,-1) end
    	  if (not player.ismoving.x) and isleft and testBotMap(player,-1, 0,"x",-1,0) then moveGrid(player,"x",-32,1,0) end
    	  if (not player.ismoving.x) and isright and testBotMap(player,1, 0,"x",-1,-1) then moveGrid(player,"x",32,-1,0)  end
	  if (not player.ismoving.z) and isin and testBotMap_d(player,1,-1) then moveGrid_d(player,1)  end
	  if (not player.ismoving.z) and isout and testBotMap_d(player,-1,0) then moveGrid_d(player,-1)  end
	end
	camera:setPosition(player.act_x - width / 2, player.act_y - height / 2)
end

function testBotMap(bot,x,y,dir,y2,dir2)
	dir2= dir2 or 0
	local n = 0
	while true do
		n = n + 1
		if map[bot.d3+1][(bot.grid_y / 32) + n] and map[bot.d3+1][(bot.grid_y / 32) + n][(bot.grid_x / 32)] and map[bot.d3+1][(bot.grid_y / 32) + n][(bot.grid_x / 32)] > 0 then 
			break
		end
	end
	if bot.jumptime == 0 then
		bot.shadowy = n + 1
	elseif bot.jumptime == 1 and dir and dir=="y" then
		bot.shadowy = n + 1
	elseif bot.jumptime == 1 then
		bot.shadowy = n
	elseif bot.jumptime == 2 then
		bot.shadowy = n
	elseif bot.jumptime == 3 then
		bot.shadowy = n
	else
		bot.shadowy = math.max(n - y,1)
	end
	if map[bot.d3+1][(bot.grid_y / 32) + y] and map[bot.d3+1][(bot.grid_y / 32) + y][(bot.grid_x / 32) + x] and map[bot.d3+1][(bot.grid_y / 32) + y][(bot.grid_x / 32) + x] > 0 then 
		if dir and dir == "y" then
			isup = false
			bot.jumptime = 4
		end
		return false
	end
	if y2 and map[bot.d3+1][(bot.grid_y / 32) + y2] and map[bot.d3+1][(bot.grid_y / 32) + y2][(bot.grid_x / 32) + x] and map[bot.d3+1][(bot.grid_y / 32) + y2][(bot.grid_x / 32) + x] > 0 then 
		if dir and dir == "y" then
			isup = false
			bot.jumptime = 4
		end
		return false
	end
	if dir and dir == "y" then
		bot.jumptime = bot.jumptime + 1
		if bot.jumptime >= 3 then
			isup = false
		end
		bot.dy=dir2
	else
		bot.dx=dir2
		if dir2 == -1 then
			imgpla1 = plar
		else
			imgpla1 = plal
		end
	end
	return true
end

function testBotMap_d(bot,z,dir2)
	if not map[bot.d3+1+z] or (map[bot.d3+1+z] and map[bot.d3+1+z][(bot.grid_y / 32)][(bot.grid_x / 32)] > 0) then 
		return false
	end
	if not map[bot.d3+1+z] or (map[bot.d3+1+z] and map[bot.d3+1+z][(bot.grid_y / 32)-1][(bot.grid_x / 32)] > 0) then 
		return false
	end
	bot.dz = dir2
	return true
end

function love.draw()
   camera:set()
   love.graphics.setColor(255,255,255,255)
   for z=5,1,-1 do
	for y=#map[z],1,-1 do
		
		for x = #map[z][1],1,-1 do
			if map[z][y][x] > 0 then
				love.graphics.draw( imglst[map[z][y][x]], x*32-z*16, y*32-z*16, 0, 1, 1, 0, 0, 0, 0 )	
			end
				if player.d3+1 + player.dz == z  and player.grid_y/32 + player.shadowy + player.dy == y  and  player.grid_x/32 + player.dx == x then	
					love.graphics.draw( imgshd, player.act_x-player.actd3-16, player.grid_y+player.shadowy*32-player.actd3-16, 0, 1, 1, 0, 0, 0, 0 )
				end
				if player.d3+1+ player.dz == z  and player.grid_y/32+ player.dy == y  and  player.grid_x/32+ player.dx == x then	
					love.graphics.draw( imgpla2, player.act_x-player.actd3-16,player.act_y-player.actd3-16, 0, 1, 1, 0, 0, 0, 0 )	
					--love.graphics.print("         "..x.."   "..y.."  "..(player.grid_x/32+1).."   "..player.grid_y/32+1, player.act_x-player.actd3-16,player.act_y-player.actd3-32-16)
				end
				if player.d3+1+ player.dz == z and player.grid_y/32-1+ player.dy == y and  player.grid_x/32+ player.dx == x then	
					
					love.graphics.draw( imgpla1, player.act_x-player.actd3-16,player.act_y-player.actd3-32-16, 0, 1, 1, 0, 0, 0, 0 )	
					
				end
		end
				
	end
	
   end
   love.graphics.setColor(255,255,255,255)
   if top then
   	love.graphics.rectangle("fill",player.act_x-player.actd3,player.act_y-player.actd3-32,32,32)
   	love.graphics.rectangle("fill",player.act_x-player.actd3,player.act_y-player.actd3,32,32)
   	love.graphics.print(player.grid_x.."   "..player.grid_y,player.act_x-16-player.actd3,player.act_y-16-player.actd3-32)
   	love.graphics.rectangle("fill",player.act_x-player.actd3,player.grid_y+player.shadowy*32-player.actd3,32,8)
   end
   camera:unset()
end
	

function love.keypressed(key)
	if key == "left" then
		isleft = true
	elseif key == "right" then
		isright = true
	elseif key == " " and (not player.ismoving.y) and not testBotMap(player,0, 1) then
		isup = true
		player.jumptime = 0
	elseif key == "up" then
		isin = true
	elseif key == "down" then
		isout = true
	elseif key == "n" then
		top = not top
	end
end

function love.keyreleased(key)
	if key == "left" then
		isleft = false
	elseif key == "right" then
		isright = false
	elseif key == " " then
		--isup = false
	elseif key == "up" then
		isin = false
		--player.d3=player.d3+1
	elseif key == "down" then
		isout = false
		--player.d3=player.d3-1
	end
end
